/*
 * Copyright 2006-2008 The FLWOR Foundation.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef ZORBA_UTIL_CONVERTERS_JSON_H
#define ZORBA_UTIL_CONVERTERS_JSON_H

#include "zorbatypes/representations.h"

#include "store/api/item.h"
#include "store/api/item_factory.h"

namespace zorba {

  //Json parse and serialize: http://www.json.org/
  bool JSON_parse(const char* aJsonString,
                  const unsigned int aLength,
                  store::Item_t& aElement,
                  xqpStringStore_t aBaseUri,
                  xqp_string& aErrorLog);

  bool JSON_serialize(const store::Item* aElement,
                      xqpStringStore_t& aJsonString,
                      xqpStringStore_t& aErrorLog);


  //Json ML parse and serialize: http://jsonml.org/
  bool JSON_ML_parse( const char* aJsonString,
                      const unsigned int aLength,
                      store::Item_t& aElement,
                      xqpStringStore_t aBaseUri,
                      xqp_string& aErrorLog);

  bool JSON_ML_serialize( const store::Item* aElement,
                          xqpStringStore_t& aJsonString,
                          xqpStringStore_t& aErrorLog);

}/*namespace zorba*/

#endif /* ZORBA_UTIL_CONVERTERS_JSON_H */
